
(* module 01 *)


procedure Box (X1, Y1, X2, Y2: integer);
begin
end;


function MainSelection: char;

var
  Ch: char;

begin
  writeln;
  writeln('TRANSFER - vers ',Vers,' ');

  write('   CP/M= ',chr(CPM_Drive+ord('A')),':');
  writeln('   MS-DOS= ',chr (MS_DOS_Drive+ord ('A')), ':');

  writeln('   Path == ', pathStr);

  writeln('1. Transfer File:     CP/M >> MS-DOS');

  writeln('2. Transfer File:   MS-DOS >> CP/M');

  writeln('3. Directory of     MS-DOS Disk');

  writeln('4. Allocation Map   MS-DOS Disk');

  writeln('5. Directory of       CP/M Disk');

  writeln('6. Erase File       MS-DOS Disk');

  writeln('7. Boot Sector      MS-DOS Disk');

  writeln ('8. Open MS-DOS SubDirectory');

  writeln('9. Quit');

  repeat
    writeln('   Enter Your Selection? ');
    read(KBD,Ch);
  until (Ch in ['1'..'9']);
  MainSelection:= Ch
end;



procedure Continue;
begin
writeln('Press [Return] to Continue..');
repeat
  read(KBD,Selection);
  until (Selection = #$D);
end;



procedure NextSector(var S: integer; var T: integer);
begin
S:= S + 1;
if (S >= NSectors) then
  begin
  S:= MinSector;
  T:= T + 1;
  end;
end;



procedure DiskError;
begin
writeln;
write('Disk I/O Error, ');
Continue;
end;



procedure BiosSelect(DriveCode: integer);
begin
end;



procedure DiscIO(Sector, Track, Address: integer);
const
dsel: array[0..3] of integer = (1,2,4,8);
var
  Side,Trk: integer;
  Saved: array [0..7] of integer;
begin
  { save scratch pad }
  For Trk := 0 to 7 do Saved[Trk] := Mem[$fb50+Trk];  
  Trk := Track div 2;
  If Track - Trk = Trk then Side := 0
                       else Side := 16;
  Side := Side + dsel[MS_DOS_Drive];
  Mem[$fb50] := MS_DOS_Drive;
  Mem[$fb51] := Trk;
  Mem[$fb52] := Sector+1;
  Mem[$fb57] := 10;
  Port[$23] := Side;
  (* writeln(lst, sector, ' ', Trk, ' ', track, ' ', MS_DOS_drive, ' ', side); *)
  Inline (
     $2a/Address         (* ld hl,(address) *)
    /$22/$53/$fb         (* ld (fb53),hl *)
    /$21/$0a/$1d         (* ld hl,1d0a *)
    /$22/$3e/$fc         (* ld (fc3e),hl *)
    /$cf                 (* rst 8 *)
    /$00                 (* defb 00 *)
    /$21/$d7/$0f         (* ld hl,0fd7 *)
    /$22/$3e/$fc         (* ld (fc3e),hl *)
    /$e6/$7f             (* and 7f *)
    /$26/$00             (* ld h,0 *)
    /$6f                 (* ld l,a *)
    /$22/biosError       (* ld (bioserror),hl *)
    );
  { Restore scratchpad }
  For Trk := 0 to 7 do Mem[$fb50+Trk] := Saved[Trk];
end;

procedure ReadSector(Sector, Track, Address: integer);
begin
     Mem[$fb55] := 0;
     DiscIO(Sector,Track,Address);
     if ord(bioserror) <> 0 then bioserror := true else bioserror := false;
end;

procedure WriteSector(Sector, Track, Address: integer);
begin
     Mem[$fb55] := 1;
     DiscIO(Sector,Track,Address);
     if ord(bioserror) <> 0 then bioserror := true else bioserror := false;
end;



procedure GetFAT;

var
  s, t, i: integer;
begin
  s := firstfatsector;
  t := 0;
  for i := 0 to fatsize-1 do begin
    ReadSector (s, t, addr (fat) + (sectorsize * i));
    NextSector (s, t)
  end
end;


procedure PutFAT;

var
  S, T, I, j: integer;

begin
  S := FirstFATSector;
  T := 0;
  for j := 1 to fatnum do
    for I := 0 to FATSize-1 do begin
      WriteSector (S,T,addr(FAT) + (SectorSize * I));
      NextSector (S,T);
    end;
end;


procedure ReadCluster(Cl: integer);
var
  I:      integer;
  Sector: integer;
  Track:  integer;
begin
Cl:= Cl - 2;
Track:= (Cl * SecsPerCluster) div NSectors;
Sector:= (Cl * SecsPerCluster) mod NSectors;
Sector:= Sector + FirstDataSector;
Track:= Track + FirstDataTrack + (Sector div NSectors);
Sector:= Sector mod NSectors;
for I:= 0 to (SecsPerCluster -1) do
  begin
  ReadSector(Sector,Track,addr( ClusterBuffer[ I * SectorSize + 1] ));
  NextSector(Sector,Track);
  end;
end;



procedure WriteCluster(Cl: integer);
var
  I:      integer;
  Sector: integer;
  Track:  integer;
begin
Cl:= Cl - 2;
Track:= (Cl * SecsPerCluster) div NSectors;
Sector:= (Cl * SecsPerCluster) mod NSectors;
Sector:= Sector + FirstDataSector;
Track:= Track + FirstDataTrack + (Sector div NSectors);
Sector:= Sector mod NSectors;
for I:= 0 to (SecsPerCluster -1) do
  begin
  WriteSector(Sector,Track,addr( ClusterBuffer[ I * SectorSize + 1] ));
  NextSector(Sector,Track);
  end;
end;



function FATPointer(Index: integer): Integer; (* 2..NClusters + 2 *)
var
  Result,I:    Integer;
  OddNum:      Boolean;
begin
I:= ((Index * 3) div 2) +1;
Result:= (FAT[I] + (256 * FAT[I + 1]));
if odd(Index) then Result:= Result shr 4;
FATPointer:= (Result and $FFF);
end;



function Break: boolean;
var
  Ch: char;
begin
if KeyPressed then
  begin
  read(KBD,Ch);
  if (Ch = ^S) then
    begin
    while not KeyPressed do;
    read(KBD,Ch);
    end;
  if (Ch = #27) then
    Break:= true
  else
    Break:= false;
  end
else
  Break:= false;
end;



(* end module 01 *)
